//--------------------------
//- axi_timer.c            -
//-                        -
//-	Created on: 16.01.2012 -
//-	    Author: Alex Tofan -
//--------------------------
#include <xparameters.h>
#include <xil_io.h>
#include "axi_timer.h"

void LoadTimer0(int LoadValue)
{
	Xil_Out32(TLR0, LoadValue);
}

void InitTimer0(void)
{
	int CfgValue = 0;
	// Configures Timer0 as follows:
	/*
	 	 * Loads Timer0 with the value stored in TLR0
	 	 * Enable Interrupts for Timer0
	 	 * Reload generate value when Timer0 reaches 0
	 	 * Count Down
	 	 * Timer0 in Generate Mode
	 */
	CfgValue = (1 << LOAD0)	|
			   (1 << ENIT0) |
			   (1 << ARHT0) |
			   (1 << UDT0)	|
			   (0 << MDT0);
	Xil_Out32(TCSR0, CfgValue);
	// Clear LOAD0 bit before starting Timer0
	CfgValue &= ~(1 << LOAD0);
	Xil_Out32(TCSR0, CfgValue);
}

void StartTimer0(void)
{
	int CfgValue = 0;
	CfgValue = Xil_In32(TCSR0);
	CfgValue |= (1 << ENT0);
	Xil_Out32(TCSR0, CfgValue);
}

void StopTimer0(void)
{
	int CfgValue = 0;
	CfgValue = Xil_In32(TCSR0);
	CfgValue &= ~(1 << ENT0);
	Xil_Out32(TCSR0, CfgValue);
}

void ClearInt(void)
{
	int CfgValue = 0;
	CfgValue = Xil_In32(TCSR0);
	CfgValue |= (1 << T0INT);
	Xil_Out32(TCSR0, CfgValue);
}
