//--------------------------
//- axi_timer.h            -
//-                        -
//-	Created on: 16.01.2012 -
//-	    Author: Alex Tofan -
//--------------------------

//------------------------------------------------------------------------------------------------
//------- Include Files --------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------
#include "xil_types.h"
#include "xparameters.h"

//------------------------------------------------------------------------------------------------
//------- AXI TIMER ------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------
// Register address
#define TCSR0   XPAR_AXI_TIMER_0_BASEADDR + 0x00
#define TLR0    XPAR_AXI_TIMER_0_BASEADDR + 0x04
#define TCR0    XPAR_AXI_TIMER_0_BASEADDR + 0x08
#define TCSR1   XPAR_AXI_TIMER_0_BASEADDR + 0x10
#define TLR1    XPAR_AXI_TIMER_0_BASEADDR + 0x14
#define TCR1    XPAR_AXI_TIMER_0_BASEADDR + 0x18
// Register specific bits
// Control/Status Register 0 (TCSR0)
#define ENALL   10
#define PWMA0   9
#define T0INT   8
#define ENT0    7
#define ENIT0   6
#define LOAD0   5
#define ARHT0   4
#define CAPT0   3
#define GENT0   2
#define UDT0    1
#define MDT0    0
// Control/Status Register 1 (TCSR1)
//#define ENALL   10
#define PWMA1   9
#define T1INT   8
#define ENT1    7
#define ENIT1   6
#define LOAD1   5
#define ARHT1   4
#define CAPT1   3
#define GENT1   2
#define UDT1    1
#define MDT1    0

void InitTimer0(void);
void StartTimer0(void);
void StopTimer0(void);
void LoadTimer0(int LoadValue);
void ClearInt(void);
