//--------------------------
//- testperiph.c                  -
//-                        -
//-	Created on: 08.12.2011 -
//-	    Author: Alex Tofan -
//--------------------------

#include <stdio.h>
#include "xparameters.h"
#include "xil_cache.h"
#include "xbasic_types.h"
#include "xgpio.h"
#include "gpio_header.h"
#include "uartlite_header.h"
#include "xspi.h"
#include "spi_header.h"
#include "xil_io.h"
#include "spi.h"
#include "AD7303.h"
#include "axi_timer.h"

static u32 AudioData[1024*1024];//[1024*1024*1];
int main() 
{
	int GPIO;
	int RxData;
	int cnt = 0;
	int offset = 0;
	const OneSecond = 32667;
	const TimeInSec = 147;
	Xil_ICacheEnable();
	Xil_DCacheEnable();

	// Initialize SPI Core
	SPI_Init();
	LoadTimer0(735);
	InitTimer0();
	StartTimer0();

	GPIO = Xil_In32(XPAR_AXI_GPIO_0_BASEADDR);

	if((GPIO & 0x1) == 1)
	{
		xil_printf(">>> Switch 1 = 1 <<<\n\r");
		xil_printf("Selected Mode: Record/Playback\n\r");
		xil_printf("# Record process started\n\r");
		xil_printf("  # Writing to LPDDR... ");

		while(cnt < (sizeof(AudioData)) / 4)
		{
			AudioData[cnt] = GetVin1();
			Xil_Out32(0xC0000000+0x100000+offset, AudioData[cnt]);
			cnt += 1;
			offset += 4;
		}

		xil_printf("Done!\n\r");
		cnt = 0;
		offset = 0;
		xil_printf("# Playback process started\n\r");
		xil_printf("  # Reading from LPDDR...\n\r");
		while(1)
		{
			while(cnt < (sizeof(AudioData)) / 4)
			{
				RxData = Xil_In32(0xC0000000+0x100000+offset);

				while((Xil_In32(TCSR0) & (1 << T0INT)) != 256);
				AD7303WriteData0((RxData & 0xFF000000) >> 24);
				AD7303Convert();
				ClearInt();

				while((Xil_In32(TCSR0) & (1 << T0INT)) != 256);
				AD7303WriteData0((RxData & 0x00FF0000) >> 16);
				AD7303Convert();
				ClearInt();

				while((Xil_In32(TCSR0) & (1 << T0INT)) != 256);
				AD7303WriteData0((RxData & 0x0000FF00) >> 8);
				AD7303Convert();
				ClearInt();

				while((Xil_In32(TCSR0) & (1 << T0INT)) != 256);
				AD7303WriteData0((RxData & 0x000000FF));
				AD7303Convert();
				ClearInt();

				cnt += 1;
				offset += 4;
			}
			cnt = 0;
			offset = 0;
		}
	}
	else
	{
		xil_printf(">>> Switch 1 = 0 <<<\n\r");
		xil_printf("Selected Mode: Live Stream\n\r");
		xil_printf("# Live streaming process started\n\r");
		while(1)
		{
			RxData = ((SPI_TransferData(0) & 0x00000FF0) >> 4);
			AD7303WriteData0((RxData & 0x000000FF));
			AD7303Convert();
		}
	}
	Xil_DCacheDisable();
	Xil_ICacheDisable();

   return 0;
}

