//--------------------------
//- spi.h                - 
//-                        -
//-	Created on: 08.12.2011 -
//-	    Author: Alex Tofan -
//--------------------------

//------------------------------------------------------------------------------------------------
//------- Include Files --------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------
#include "xil_types.h"
#include "xparameters.h"

//------------------------------------------------------------------------------------------------
//------- SPI ------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------
// Register address
#define SRR         XPAR_AXI_SPI_0_BASEADDR + 0x40
#define SPICR       XPAR_AXI_SPI_0_BASEADDR + 0x60
#define SPISR       XPAR_AXI_SPI_0_BASEADDR + 0x64
#define SPIDTR      XPAR_AXI_SPI_0_BASEADDR + 0x68
#define SPIDRR      XPAR_AXI_SPI_0_BASEADDR + 0x6C
#define SPISSR      XPAR_AXI_SPI_0_BASEADDR + 0x70
#define SPI_T_FIFO  XPAR_AXI_SPI_0_BASEADDR + 0x74
#define SPI_R_FIFO  XPAR_AXI_SPI_0_BASEADDR + 0x78
#define DGIER       XPAR_AXI_SPI_0_BASEADDR + 0x1C
#define IPISR       XPAR_AXI_SPI_0_BASEADDR + 0x20
#define IPIER       XPAR_AXI_SPI_0_BASEADDR + 0x28
// Register specific bits
// SPI Control Register (SPICR)
#define LSBFirst            9
#define MasterTranInh       8
#define ManualSlaveAssEn    7
#define RxFifoReset         6
#define TxFifoReset         5
#define CHPA                4
#define CPOL                3
#define Master              2
#define SPE                 1
#define LOOP                0
// SPI Status Register (SPISR)
#define SlaveModeSel        5
#define MODF                4
#define TxFull              3
#define TxEmpty             2
#define RxFull              1
#define RxEmpty             0
// SPI Slave Select Register (SPISSR)
#define SS0                 0
// Device Global Interrupt Enable Register (DGIER)
#define GIE                 31
// IP Interrupt Status Register
#define DDRNotEmpty         8
#define SlaveModeSel_int    7
#define TxFifoHalfEmpty     6
#define DDROverRun          5
#define DDRFull             4
#define DTRUnderRun         3
#define DTREmpty            2
#define SlaveMODF           1
#define MODF_int            0

//------------------------------------------------------------------------------------------------
//------- Function prototypes --------------------------------------------------------------------
//------------------------------------------------------------------------------------------------
int SPI_Init(void);
void SPI_SS0n_ON(void);
void SPI_SSn_OFF(void);
void SPI_SS1n_ON(void);
int SPI_TransferData(char ss);
int SPI_ReadGyro(int first);
void delay_ms(u32 ms_count);
void PrintDegreesPos(int x);

